//--------------------------------------------------------------------------------------
//Application Name:				ZDice
//
//Application function:			Random dice hits (1 - 5 d 6 dices)
//
//Version/build date:			1.0alfa/09-08-06
//
//Autor:						Morock
//
//--------------------------------------------------------------------------------------


#include "stdafx.h"
#include "ZDice.h"

#define MAX_LOADSTRING 100
#define _CRT_RAND_S

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK    MainForm(HWND, UINT, WPARAM, LPARAM);
int                 HitDice (void);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_ZDICE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ZDICE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}




ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ZDICE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_ZDICE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;
	
   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_DLGFRAME|WS_SYSMENU|WS_CAPTION ,
      CW_USEDEFAULT, 0, 300, 300, NULL, NULL, hInstance, NULL);
   if (!hWnd)
   {
	   return FALSE;
   }
   HDC dc = GetDC(hWnd);
   //TextOut(dc, 10, 10, _T("Good play from ZDice to you!!!"),30);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   srand( (unsigned)time( NULL ) );
	ShowWindow(hWnd, SW_HIDE);
	DialogBox(hInst, MAKEINTRESOURCE(IDD_MAINFORM), hWnd, MainForm);
	SendMessage(GetDlgItem(hWnd,IDD_MAINFORM),WM_SETICON,WPARAM(ICON_BIG),LPARAM(GetDlgItem(hWnd,IDI_ZDICE)));
	SendMessage(GetDlgItem(hWnd,IDD_MAINFORM),WM_SETICON,WPARAM(ICON_SMALL),LPARAM(GetDlgItem(hWnd,IDI_ZDICE)));	
   return TRUE;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

#pragma warning(disable : 4996)
// Message handler for Main box.
INT_PTR CALLBACK MainForm(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			return (INT_PTR)TRUE;
		}


	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL || LOWORD(wParam) == IDCLOSE)
		{
			EndDialog(hDlg, LOWORD(wParam));
			ExitProcess(0);
			return (INT_PTR)TRUE;
		}
		switch(wParam)
		{
		case IDC_BUTTON1D6:
			{
				int Hit = HitDice();
				wchar_t  Buf[3];
				_ltow(long(Hit), Buf, 10); 
				SetWindowText (GetDlgItem(hDlg,IDC_STATIC), Buf);
				break;
			}
		case IDC_BUTTON2D6:
			{
				int Hit1 = HitDice();
				int Hit2 = HitDice();
				wchar_t  Buf[10];
				wchar_t  Buf1[3];
				wchar_t  Buf2[3];
				_ltow(long(Hit1), Buf1, 10); 
				_ltow(long(Hit2), Buf2, 10); 
				wcsncpy_s( Buf, _countof(Buf), Buf1, 1 );
				wcsncpy(Buf+1, _T("+"), 1);
				wcsncpy(Buf+2, Buf2, 1);
				wcsncpy(Buf+3, _T("="), 1);
				_ltow(long(Hit1+Hit2), Buf1, 10); 
				wcsncpy(Buf+4, Buf1, 3);
				SetWindowText (GetDlgItem(hDlg,IDC_STATIC), Buf);
				break;
			}
		case IDC_BUTTON3D6:
			{
				int Hit1 = HitDice();
				int Hit2 = HitDice();
				int Hit3 = HitDice();
				wchar_t  Buf[10];
				wchar_t  Buf1[3];
				wchar_t  Buf2[3];
				wchar_t  Buf3[3];
				_ltow(long(Hit1), Buf1, 10); 
				_ltow(long(Hit2), Buf2, 10); 
				_ltow(long(Hit3), Buf3, 10); 
				wcsncpy_s( Buf, _countof(Buf), Buf1, 1 );
				wcsncpy(Buf+1, _T("+"), 1);
				wcsncpy(Buf+2, Buf2, 1);
				wcsncpy(Buf+3, _T("+"), 1);
				wcsncpy(Buf+4, Buf3, 1);
				wcsncpy(Buf+5, _T("="), 1);
				_ltow(long(Hit1+Hit2+Hit3), Buf1, 10); 
				wcsncpy(Buf+6, Buf1, 3);
				SetWindowText (GetDlgItem(hDlg,IDC_STATIC), Buf);
				break;
			}
		case IDC_BUTTON4D6:
			{
				int Hit1 = HitDice();
				int Hit2 = HitDice();
				int Hit3 = HitDice();
				int Hit4 = HitDice();
				wchar_t  Buf[15];
				wchar_t  Buf1[3];
				wchar_t  Buf2[3];
				wchar_t  Buf3[3];
				wchar_t  Buf4[3];
				_ltow(long(Hit1), Buf1, 10); 
				_ltow(long(Hit2), Buf2, 10); 
				_ltow(long(Hit3), Buf3, 10); 
				_ltow(long(Hit4), Buf4, 10); 
				wcsncpy_s( Buf, _countof(Buf), Buf1, 1 );
				wcsncpy(Buf+1, _T("+"), 1);
				wcsncpy(Buf+2, Buf2, 1);
				wcsncpy(Buf+3, _T("+"), 1);
				wcsncpy(Buf+4, Buf3, 1);
				wcsncpy(Buf+5, _T("+"), 1);
				wcsncpy(Buf+6, Buf4, 1);
				wcsncpy(Buf+7, _T("="), 1);
				_ltow(long(Hit1+Hit2+Hit3+Hit4), Buf1, 10); 
				wcsncpy(Buf+8, Buf1, 3);
				SetWindowText (GetDlgItem(hDlg,IDC_STATIC), Buf);
				break;
			}
		case IDC_BUTTON5D6:
			{
				int Hit1 = HitDice();
				int Hit2 = HitDice();
				int Hit3 = HitDice();
				int Hit4 = HitDice();
				int Hit5 = HitDice();
				wchar_t  Buf[15];
				wchar_t  Buf1[3];
				wchar_t  Buf2[3];
				wchar_t  Buf3[3];
				wchar_t  Buf4[3];
				wchar_t  Buf5[3];
				_ltow(long(Hit1), Buf1, 10); 
				_ltow(long(Hit2), Buf2, 10); 
				_ltow(long(Hit3), Buf3, 10); 
				_ltow(long(Hit4), Buf4, 10); 
				_ltow(long(Hit5), Buf5, 10); 
				wcsncpy_s( Buf, _countof(Buf), Buf1, 1 );
				wcsncpy(Buf+1, _T("+"), 1);
				wcsncpy(Buf+2, Buf2, 1);
				wcsncpy(Buf+3, _T("+"), 1);
				wcsncpy(Buf+4, Buf3, 1);
				wcsncpy(Buf+5, _T("+"), 1);
				wcsncpy(Buf+6, Buf4, 1);
				wcsncpy(Buf+6, _T("+"), 1);
				wcsncpy(Buf+7, Buf5, 1);
				wcsncpy(Buf+8, _T("="), 1);
				_ltow(long(Hit1+Hit2+Hit3+Hit4+Hit5), Buf1, 10); 
				wcsncpy(Buf+9, Buf1, 3);
				SetWindowText (GetDlgItem(hDlg,IDC_STATIC), Buf);
				break;
			}
		case IDM_ABOUT:
			{
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hDlg, About);
			break;
			}
		case IDM_EXIT:
			{
			EndDialog(hDlg, LOWORD(wParam));
			ExitProcess(0);
			return (INT_PTR)TRUE;
			}
		}
		break;
	}
	//	int wmId, wmEvent;
	//	wmId    = LOWORD(wParam);
	//	wmEvent = HIWORD(wParam);
	//	// Parse the menu selections:
	//	switch (wmId)
	//	{
	//	
	//	default:
	//		return DefWindowProc(hDlg, message, wParam, lParam);
	//	}
	//	break;
	//}
	return (INT_PTR)FALSE;
}

int HitDice (void)
{
	int RANGE_MIN = 1;
	int RANGE_MAX = 6;	
	return int(((double) rand() / 
		(double) RAND_MAX) * RANGE_MAX + RANGE_MIN);
;
}